#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property indicator_level1 0
#property  indicator_color1  Aqua
#property  indicator_color2  Red

extern int SignalSMA = 12;
//---- indicator buffers
double     MacdBuffer[];
double     SignalBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,MacdBuffer);
   SetIndexBuffer(1,SignalBuffer);
//---- name for DataWindow and indicator subwindow label
   SetIndexEmptyValue( 0,0.0);
   SetIndexEmptyValue( 1,0.0); 
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   if (limit < 1) limit = 1;
//---- macd counted in the 1-st buffer
   for(int i=limit; i>=0; i--)
      {
      if(Open[i]<Close[i])MacdBuffer[i]=MacdBuffer[i+1]+1;
      if(Open[i]>Close[i])MacdBuffer[i]=MacdBuffer[i+1]-1;
      if(Open[i]==Close[i])MacdBuffer[i]=MacdBuffer[i+1];
      }
//---- signal line counted in the 2-nd buffer
   for(i=limit; i>=0; i--)
      SignalBuffer[i]=iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_SMA,i);
//---- done
   return(0);
  }
//+------------------------------------------------------------------+